Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.sort
Class GenericAtomicComparer

    java.lang.Object
      net.sf.saxon.sort.GenericAtomicComparer

All Implemented Interfaces:
  Serializable, AtomicComparer

    public class GenericAtomicComparer

extends Object
implements AtomicComparer, Serializable

An AtomicComparer used for comparing atomic values of arbitrary item types. It encapsulates a Collator that is used when the values to be compared are strings. It also supports a separate method for testing equality of items, which can be used for data types that are not ordered.

Author:
  Michael H. Kay
See Also:
  Serialized Form

Constructor Summary
`GenericAtomicComparer(StringCollator collator, Configuration config)`
`GenericAtomicComparer(StringCollator collator, XPathContext conversion)` Create an GenericAtomicComparer

Method Summary
`int` | `compareAtomicValues(AtomicValue a, AtomicValue b)` Compare two AtomicValue objects according to the rules for their data type.
`boolean` | `comparesEqual(AtomicValue a, AtomicValue b)` Compare two AtomicValue objects for equality according to the rules for their data type.
`ComparisonKey` | `getComparisonKey(AtomicValue a)` Get a comparison key for an object.
`StringCollator` | `getStringCollator()` Get the underlying string collator
`static AtomicComparer` | `makeAtomicComparer(BuiltInAtomicType type0, BuiltInAtomicType type1, StringCollator collator, Configuration config)` Factory method to make a GenericAtomicComparer for values of known types

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### GenericAtomicComparer

    public GenericAtomicComparer(StringCollator collator,
                                 XPathContext conversion)

  Create an GenericAtomicComparer

  Parameters:
    `collator` - the collation to be used
    `conversion` - a context, used when converting untyped atomic values to the target type.

### GenericAtomicComparer

    public GenericAtomicComparer(StringCollator collator,
                                 Configuration config)

Method Detail

### makeAtomicComparer

    public static AtomicComparer makeAtomicComparer(BuiltInAtomicType type0,
                                                    BuiltInAtomicType type1,
                                                    StringCollator collator,
                                                    Configuration config)

  Factory method to make a GenericAtomicComparer for values of known types

  Parameters:
    `type0` - primitive type of the first operand
    `type1` - primitive type of the second operand
    `collator` - the collation to be used, if any. This is supplied as a NamedCollation object which encapsulated both the collation URI and the collation itself.
    `config` - the configuration
  Returns:
    a GenericAtomicComparer for values of known types

### getStringCollator

    public StringCollator getStringCollator()

  Get the underlying string collator

### compareAtomicValues

    public int compareAtomicValues(AtomicValue a,
                                   AtomicValue b)

  Compare two AtomicValue objects according to the rules for their data type. UntypedAtomic values are compared as if they were strings; if different semantics are wanted, the conversion must be done by the caller.

  Specified by:
    `compareAtomicValues` in interface `AtomicComparer`
  Parameters:
    `a` - the first object to be compared. It is intended that this should be an instance of AtomicValue, though this restriction is not enforced. If it is a StringValue, the collator is used to compare the values, otherwise the value must implement the java.util.Comparable interface.
    `b` - the second object to be compared. This must be comparable with the first object: for example, if one is a string, they must both be strings.
  Returns:
    <0 if a0 if a>b
  Throws:
    `ClassCastException` - if the objects are not comparable

### comparesEqual

    public boolean comparesEqual(AtomicValue a,
                                 AtomicValue b)

  Compare two AtomicValue objects for equality according to the rules for their data type. UntypedAtomic values are compared by converting to the type of the other operand.

  Specified by:
    `comparesEqual` in interface `AtomicComparer`
  Parameters:
    `a` - the first object to be compared. It is intended that this should be an instance of AtomicValue, though this restriction is not enforced. If it is a StringValue, the collator is used to compare the values, otherwise the value must implement the equals() method.
    `b` - the second object to be compared. This must be comparable with the first object: for example, if one is a string, they must both be strings.
  Returns:
    <0 if a0 if a>b
  Throws:
    `ClassCastException` - if the objects are not comparable

### getComparisonKey

    public ComparisonKey getComparisonKey(AtomicValue a)

  Get a comparison key for an object. This must satisfy the rule that if two objects are equal, then their comparison keys are equal, and vice versa. There is no requirement that the comparison keys should reflect the ordering of the underlying objects.

  Specified by:
    `getComparisonKey` in interface `AtomicComparer`

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.